using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;
using System.Data;

namespace Toolglass
{
	/// <summary>
	/// Summary description for Form1.
	/// </summary>
	public class Form1 : System.Windows.Forms.Form
	{
		private Sdgt.SdgManager sdgManager1;
		private System.ComponentModel.IContainer components;

		private Pen CurrentPen;
		private Point LastPoint;
		private ToolglassForm MyToolGlass;

		public Form1()
		{
			//
			// Required for Windows Form Designer support
			//
			InitializeComponent();

			LastPoint = new Point(sdgManager1.Mice[0].X, sdgManager1.Mice[0].Y);
			CurrentPen = new Pen(new SolidBrush(Color.Black), 5);

			MyToolGlass = new ToolglassForm(0);
			MyToolGlass.Show();
			MyToolGlass.ColorChanged += new ColorChangedEventHandler(MyToolGlass_ColorChanged);
			sdgManager1.AttachEventSinkWidget(MyToolGlass, MyToolGlass);
			sdgManager1.Mice[1].Visible = false;   //hide the cursor of the mouse that control the movement of the Toolglass

			MyToolGlass.Closed += new EventHandler(MyToolGlass_Closed);
			//
			// TODO: Add any constructor code after InitializeComponent call
			//
		}

		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if (components != null) 
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
			this.components = new System.ComponentModel.Container();
			this.sdgManager1 = new Sdgt.SdgManager(this.components);
			// 
			// sdgManager1
			// 
			this.sdgManager1.EmulateSystemMouseMode = Sdgt.EmulateSystemMouseModes.Park;
			this.sdgManager1.Keyboards = null;
			this.sdgManager1.Mice = null;
			this.sdgManager1.MouseToFollow = 0;
			this.sdgManager1.ParkSystemMouseLocation = new System.Drawing.Point(350, 350);
			this.sdgManager1.RelativeTo = this;
			this.sdgManager1.MouseMove += new Sdgt.SdgMouseEventHandler(this.sdgManager1_MouseMove);
			// 
			// Form1
			// 
			this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
			this.ClientSize = new System.Drawing.Size(728, 502);
			this.Name = "Form1";
			this.Text = "Form1";

		}
		#endregion

		/// <summary>
		/// The main entry point for the application.
		/// </summary>
		[STAThread]
		static void Main() 
		{
			Application.Run(new Form1());
		}

		private void sdgManager1_MouseMove(object sender, Sdgt.SdgMouseEventArgs e) {
			// movement comes from the mouse that control the pen
			if (e.ID == 0){
				if (MouseButtons.Left == e.Button){
					Graphics g = this.CreateGraphics();
					g.DrawLine(CurrentPen, new Point(e.X, e.Y), LastPoint);
				}
				LastPoint = new Point(e.X, e.Y);
				// movement comes from the mouse that control the Toolglass
			}else{
				MyToolGlass.Location = new Point(sdgManager1.Mice[e.ID].Xabs, sdgManager1.Mice[e.ID].Yabs);
			}		
		}

		private void MyToolGlass_ColorChanged(Color newColor) {
			CurrentPen.Color = newColor;
		}

		private void MyToolGlass_Closed(object sender, EventArgs e) {
			this.Close();
		}
	}
}
