using System;
using System.Collections;
using System.ComponentModel;
using System.Drawing;
using System.Windows.Forms;

namespace Toolglass
{
	public delegate void ColorChangedEventHandler(Color newColor);

	public class ToolglassForm : Sdgt.SdgForm
	{
		private System.Windows.Forms.Button button1;
		private System.Windows.Forms.Button button2;
		private System.Windows.Forms.Button button3;
		private System.Windows.Forms.Button button4;
		private System.Windows.Forms.Button button5;
		private System.Windows.Forms.Button button6;
		private System.Windows.Forms.Button button7;
		private System.Windows.Forms.Button button8;
		private System.Windows.Forms.Button button9;
		private System.ComponentModel.IContainer components = null;

		private ArrayList Buttons;
		private Color[] ButtonColors = {Color.Red, Color.Blue, Color.Purple, Color.Yellow, Color.Pink, Color.Black, Color.Orange, Color.Cyan, Color.Magenta};
		private int CurrentUser;

		public event ColorChangedEventHandler ColorChanged; //declare the event handler

		public ToolglassForm(int User)
		{
			// This call is required by the Windows Form Designer.
			InitializeComponent();

			Buttons = new ArrayList();
			Buttons.Add((object)button1);
			Buttons.Add((object)button2);
			Buttons.Add((object)button3);
			Buttons.Add((object)button4);
			Buttons.Add((object)button5);
			Buttons.Add((object)button6);
			Buttons.Add((object)button7);
			Buttons.Add((object)button8);
			Buttons.Add((object)button9);

			CurrentUser = User;

			for (int i = 0; i < Buttons.Count; ++i){
				Button b = (Button)Buttons[i];
				b.BackColor = ButtonColors[i];
			}
			// TODO: Add any initialization after the InitializeComponent call
		}

		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if (components != null) 
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
			this.button1 = new System.Windows.Forms.Button();
			this.button2 = new System.Windows.Forms.Button();
			this.button3 = new System.Windows.Forms.Button();
			this.button4 = new System.Windows.Forms.Button();
			this.button5 = new System.Windows.Forms.Button();
			this.button6 = new System.Windows.Forms.Button();
			this.button7 = new System.Windows.Forms.Button();
			this.button8 = new System.Windows.Forms.Button();
			this.button9 = new System.Windows.Forms.Button();
			this.SuspendLayout();
			// 
			// button1
			// 
			this.button1.FlatStyle = System.Windows.Forms.FlatStyle.Flat;
			this.button1.Location = new System.Drawing.Point(0, 0);
			this.button1.Name = "button1";
			this.button1.Size = new System.Drawing.Size(64, 64);
			this.button1.TabIndex = 0;
			// 
			// button2
			// 
			this.button2.FlatStyle = System.Windows.Forms.FlatStyle.Flat;
			this.button2.Location = new System.Drawing.Point(64, 0);
			this.button2.Name = "button2";
			this.button2.Size = new System.Drawing.Size(64, 64);
			this.button2.TabIndex = 1;
			// 
			// button3
			// 
			this.button3.FlatStyle = System.Windows.Forms.FlatStyle.Flat;
			this.button3.Location = new System.Drawing.Point(128, 0);
			this.button3.Name = "button3";
			this.button3.Size = new System.Drawing.Size(64, 64);
			this.button3.TabIndex = 2;
			// 
			// button4
			// 
			this.button4.FlatStyle = System.Windows.Forms.FlatStyle.Flat;
			this.button4.Location = new System.Drawing.Point(0, 64);
			this.button4.Name = "button4";
			this.button4.Size = new System.Drawing.Size(64, 64);
			this.button4.TabIndex = 3;
			// 
			// button5
			// 
			this.button5.FlatStyle = System.Windows.Forms.FlatStyle.Flat;
			this.button5.Location = new System.Drawing.Point(64, 64);
			this.button5.Name = "button5";
			this.button5.Size = new System.Drawing.Size(64, 64);
			this.button5.TabIndex = 4;
			// 
			// button6
			// 
			this.button6.FlatStyle = System.Windows.Forms.FlatStyle.Flat;
			this.button6.Location = new System.Drawing.Point(128, 64);
			this.button6.Name = "button6";
			this.button6.Size = new System.Drawing.Size(64, 64);
			this.button6.TabIndex = 5;
			// 
			// button7
			// 
			this.button7.FlatStyle = System.Windows.Forms.FlatStyle.Flat;
			this.button7.Location = new System.Drawing.Point(0, 128);
			this.button7.Name = "button7";
			this.button7.Size = new System.Drawing.Size(64, 64);
			this.button7.TabIndex = 6;
			// 
			// button8
			// 
			this.button8.FlatStyle = System.Windows.Forms.FlatStyle.Flat;
			this.button8.Location = new System.Drawing.Point(64, 128);
			this.button8.Name = "button8";
			this.button8.Size = new System.Drawing.Size(64, 64);
			this.button8.TabIndex = 7;
			// 
			// button9
			// 
			this.button9.FlatStyle = System.Windows.Forms.FlatStyle.Flat;
			this.button9.Location = new System.Drawing.Point(128, 128);
			this.button9.Name = "button9";
			this.button9.Size = new System.Drawing.Size(64, 64);
			this.button9.TabIndex = 8;
			// 
			// ToolglassForm
			// 
			this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
			this.ClientSize = new System.Drawing.Size(192, 192);
			this.Controls.Add(this.button9);
			this.Controls.Add(this.button8);
			this.Controls.Add(this.button7);
			this.Controls.Add(this.button6);
			this.Controls.Add(this.button5);
			this.Controls.Add(this.button4);
			this.Controls.Add(this.button3);
			this.Controls.Add(this.button2);
			this.Controls.Add(this.button1);
			this.Name = "ToolglassForm";
			this.Opacity = 0.5;
			this.SdgMouseDown += new Sdgt.SdgMouseEventHandler(this.ToolglassForm_SdgMouseDown);
			this.ResumeLayout(false);

		}
		#endregion

		private void ToolglassForm_SdgMouseDown(object sender, Sdgt.SdgMouseEventArgs e) {
			if (e.ID == CurrentUser){
				for (int i = 0; i < Buttons.Count; ++i){
					if (Buttons[i] == sender){       
						if (null != ColorChanged) {
							//Fire the Color Changed event
							ColorChanged(ButtonColors[i]);
						}
					}

				}
			}
		}
	}
}

